BackgroundObject = class(function(self,_x,_y)
	self.pos = {x=_x,y=_y}
	self.size = math.random(5,15)
	self.m_speed = math.random(10,30)
	self.velo = {x=0,y=0}
	self.colorA = {}
	self.colorB = {}
	self.colorA[1] = {50,0,0,255}
	self.colorA[2] = {0,50,0,255}
	self.colorA[3] = {0,0,50,255}
	self.colorA[4] = {50,50,0,255}
	self.colorA[5] = {0,50,50,255}
	self.colorA[6] = {50,0,50,255}
	self.colorB[1] = {150,0,0,255}
	self.colorB[2] = {0,150,0,255}
	self.colorB[3] = {0,0,150,255}
	self.colorB[4] = {150,150,0,255}
	self.colorB[5] = {0,150,150,255}
	self.colorB[6] = {150,0,150,255}
	self.color = math.random(1,6)

	return self
end)

BackgroundObject.Update = function (self,dt)
	self:RandomVelocity(math.random(0,360),dt)
	self:CheckMaxVel()
	self:Move()
end

BackgroundObject.ChangeColor = function (self,i)
	if i == nil or i > #self.colorA or i < 1 then
		self.color = self.color + 1
		if self.color > #self.colorA then
			self.color = 1
		end
	else
		self.color = i
	end
end

BackgroundObject.Render = function (self)
	love.graphics.setColor(self.colorA[self.color])
	love.graphics.rectangle( "fill", self.pos.x-3,self.pos.y-3,self.size+6,self.size+6 )
	love.graphics.setColor(self.colorB[self.color])
	love.graphics.rectangle( "fill", self.pos.x,self.pos.y,self.size,self.size )
end

BackgroundObject.RotateVerts = function(self,r,s)
	for i=1,4 do
		self.verts[i*2-1] = self.verts[i*2-1]*math.sin(r)*s
		self.verts[i*2] = self.verts[i*2]*math.cos(r)*s
	end
end

BackgroundObject.CheckMaxVel = function(self)
	if (self.velo.x^2)+(self.velo.y^2) > self.size then
		self.velo = {x=0,y=0}
		self:ChangeColor()
	end
end
BackgroundObject.RandomVelocity = function(self,r,s)
	self.velo.x = self.velo.x + math.sin(r)*s
	self.velo.y = self.velo.y + math.cos(r)*s
end

BackgroundObject.Move = function(self)
	self.pos.x = self.pos.x + self.velo.x
	self.pos.y = self.pos.y + self.velo.y
	if self.pos.x > G_WW+self.size then self.pos.x = -self.size end
	if self.pos.x < -self.size then self.pos.x = G_WW+self.size end
	if self.pos.y > G_WH+self.size then self.pos.y = -self.size end
	if self.pos.y < -self.size then self.pos.y = G_WH+self.size end
end
