GameBlock = class(function(self,_parent,_x,_y,_r,_g,_b,_d)
	self.colorA = {_r,_g,_b,255}
	self.colorB = {math.min(125,_r),math.min(125,_g),math.min(125,_b),255}
	self.parent = _parent
	self.pos = {x=_x,y=_y}
	self.direction = _d
	self.type = 0 --dunno what to use this yet for
	return self
end)

GameBlock.Collision = function(self,x,y,t)
		local d = 0
		if self.pos.x-x == 1 then d = 2
		elseif self.pos.y-y == -1 then d = 3
		elseif self.pos.y-y == 1 then d = 1
		elseif self.pos.x-x == -1 then d = 4
		end
		print("direction: " .. d)
		if d ~= 0 then
			return true
		else
			return false
		end
end

GameBlock.Move = function(self,x,y)
	self.pos.x = self.pos.x + x
	self.pos.y = self.pos.y + y
end

GameBlock.Render = function (self,_gx,_gy,_s)
	local x,y = self:GetPos(true)
	--love.graphics.setColor(150,150,150,255)
	love.graphics.setColor(self.colorB)
	love.graphics.rectangle( "fill", x*_s+_gx+1, y*_s+_gy+1, _s-2, _s-2)
	love.graphics.setColor(self.colorA)
	love.graphics.rectangle( "fill", x*_s+_gx+3, y*_s+_gy+3, _s-6, _s-6)
end

GameBlock.GetPos = function(self,bool)
	--bool is true for grid position and false/nil for local
	if bool then
		return self.parent.pos.x+self.pos.x,self.parent.pos.y+self.pos.y
	end
	return self.pos.x,self.pos.y
end

GameBlock.RotPos = function(self,a,b,bool)
	--bool is true for dry run
	local x = self.pos.y*a
	local y = self.pos.x*b
	if bool then
		x = self.parent.pos.x+x
		y = self.parent.pos.y+y
		return x,y,self:Rotate(true)
	else
		self.pos.x = x
		self.pos.y = y
		self:Rotate()
	end
end

GameBlock.Rotate = function(self,bool,cw)
	if self.direction == 0 then
		return self.direction
	else
		local n = 1
		local old = self.direction
		if not cw then n = n*-1 end
		self.direction = self.direction + n
		if self.direction < 1 then self.direction = 4 end
		if self.direction > 4 then self.direction = 1 end
	end
end

GameBlock.Destroy = function (self)
	self = nil
end

GameBlock.SetPos = function(self,x,y,bool)
	if bool then
		local px,py = self.parent:GetPos()
		self.pos = {x=x+px,y=y+py}
	else
		self.pos = {x=x,y=y}
	end
end

GameBlock.SetParent = function (self,_parent,_bool)
	local bool = _bool or false
	local x,y = self:GetPos(bool)
	self.parent = _parent
	self:SetPos(x,y,bool)
end

GameBlock.GetColour = function (self)
	return self.color.r,self.color.g,self.color.b
end

GameBlock.GetDir = function (self,bool)
		return self.direction
end
