require "class"
require "background"
require "block"
require "tiles"
require "gameGrid"
require "player"

function love.load()
math.randomseed( os.time() )
math.random(); math.random(); math.random()
G_HighScore = 0
if love.filesystem.exists( "HIGHSCORE" ) then
	G_HighScore = LoadHighScore()
end
G_BGC = 1
love.graphics.setBackgroundColor( 0,0,0 )
--Music
GenerateMusicList()
----Sounds
G_SoundScore = love.audio.newSource( "sound/score.wav", "static" )
G_SoundEnd = love.audio.newSource( "sound/game_end.wav", "static" )
--G_SoundTile = love.audio.newSource( "sound/", "static" )
--
local _, _, flags = love.window.getMode()
local width, height = love.window.getDesktopDimensions( flags.display )
--width = width - 10
--height = height - 10 - 50
local success = love.window.setMode( width, height, flags )
love.window.setPosition( 0, 0, flags.display )
G_WW = width
G_WH = height
G_FH = 40/1050*height
--DAFont = love.graphics.newFont("fonts/editundo.ttf", 20);
G_GfxTextOffsetY = 200/1050*height
G_GfxTextOffsetX = 550/1680*width
ENDFont = love.graphics.newFont("fonts/editundo.ttf", G_FH);
love.graphics.setFont(ENDFont);
G_GameSpeed = 2
G_GameTimer = 0
DDText = ""
G_GameScore = 0
G_GamePaused = true
G_GameEnded = false
love.keyboard.setKeyRepeat( false )
G_MusicEnabled = true
	if G_Music_Current ~= 0 then
	G_Music[G_Music_Current].file:play()
end
	G_PlayerCount = 0
	SetupPlayers()
	G_Sensitivity = {u=0.5,d=0.5,h=0.5}
	GenBackGround(60)

	--DebugPlayerCount()
	InitRegistery()
	G_QuitVote = 0
end

function love.update(dt)
CycleBgColour(dt)
UpdateBackGround(dt)
	UpdatePlayers(dt)
	if G_QuitVote > 0 and G_QuitVote >= G_PlayerCount then
		love.event.quit()
	end
end

function CycleBgColour(dt)
	G_BGC = G_BGC + dt
	if G_BGC > 255 then G_BGC = 0 end
end

function love.draw()
	DrawBackGround()
	RenderPlayers()
	love.graphics.setColor(255,255,255,255)
	--love.graphics.print("FPS: "..tostring(love.timer.getFPS( )), 10, 10)
	--love.graphics.print("Debug: " .. DDText, 350, 10)
	local score = "Highscore: " .. 	G_HighScore
	love.graphics.print(score , (G_WW-string.len(score)*G_FH/2)/2, 3)
	if G_PlayerCount == 0 then
		local s_helpa = "Plug in a controller to play."
		local s_helpb = "F1 and F2 to add/remove Keyboard Players"
		love.graphics.print(s_helpa, (G_WW-string.len(s_helpa)*G_FH/2)/2, G_WH/2)
		love.graphics.print(s_helpb , (G_WW-string.len(s_helpb)*G_FH/2)/2, G_WH/2+G_FH)
	end
	if G_MusicEnabled and G_Music[G_Music_Current] ~= nil then
		love.graphics.print("Now Playing: " .. G_Music[G_Music_Current].name, 4, G_WH-G_FH-3)
	else
		love.graphics.print("Press M for music. ", 4, G_WH-G_FH-3)
	end
--	if G_GamePaused then
--		love.graphics.setColor(0,0,0,150)
--		love.graphics.rectangle( "fill", 70, 70, G_WW-70*2, G_WH-70*2, 10,10,5 )
--		love.graphics.setColor(255,255,255,255)
--		if G_GameEnded then
--			love.graphics.print("::GAME OVER::\n\nPress ENTER to Restart.\n\nPress ESCAPE to quit.", G_GfxTextOffsetX, G_GfxTextOffsetY)
--		else
--			love.graphics.print("::GAME PAUSED::\n\nPress ENTER to Continue.\n\nPress ESCAPE to quit.", G_GfxTextOffsetX, G_GfxTextOffsetY)
--		end
--	end
	--love.graphics.print("Speed: " .. math.floor(G_GameSpeed*100)/100, 350, 10)
end

function love.keypressed(sKey,sScanCode,bRepeat)
	FakeJKeyBoardPlayer(sKey)
	if sKey == "return" then

	elseif sKey == "m" then
		ToggleMusic()
	elseif sKey == "escape" then
		love.event.quit()
	elseif sKey == "f1" then
		SetupKeyBoardPlayer(1)
	elseif sKey == "f2" then
		SetupKeyBoardPlayer(2)
	end
end

function love.keyreleased(sKey, sScancode )
end

function love.mousepressed( x, y, button, istouch )
end

function love.mousereleased( x, y, button, istouch )
end

function love.mousemoved( x, y, dx,dy )
end
function HSV(h, s, v)
    if s <= 0 then return v,v,v end
    h, s, v = h/256*6, s/255, v/255
    local c = v*s
    local x = (1-math.abs((h%2)-1))*c
    local m,r,g,b = (v-c), 0,0,0
    if h < 1     then r,g,b = c,x,0
    elseif h < 2 then r,g,b = x,c,0
    elseif h < 3 then r,g,b = 0,c,x
    elseif h < 4 then r,g,b = 0,x,c
    elseif h < 5 then r,g,b = x,0,c
    else              r,g,b = c,0,x
    end return (r+m)*255,(g+m)*255,(b+m)*255
end

function DDPrint(sText)
	DDText = DDText .. "\n" .. sText
end

function SpeedUp(n)
	G_GameSpeed = G_GameSpeed * 0.95
end


function GameEnd()
--love.graphics.setFont(ENDFont);
	G_SoundEnd:play()
	SaveHighScore(G_GameScore)
	G_GamePaused = true
	G_GameEnded = true
end

function GameStart()
--love.graphics.setFont(DAFont);
	G_GameSpeed = 2
	G_GamePaused = false
	G_GameEnded = false
	for k,v in pairs(G_Players) do
		v:GameStart()
	end
end

function SaveHighScore(score)
	local highest = false
		if score > G_HighScore then
			G_HighScore = score
			highest = true
		end
		if highest then
			local file, errorstr = love.filesystem.newFile( "HIGHSCORE", "w" )
			if errorstr then
				print(errorstr)
			else
				local success, err = file:write( G_HighScore )
				file:close()
				if err then
					print(err)
				end
			end
		end
	return highest
end

function LoadHighScore()
	local n = 0
	--Read HighScore
	local contents, size = love.filesystem.read( "HIGHSCORE" )
	if tonumber(contents) then n = tonumber(contents) end
	--Return
	return n
end

function ToggleMusic()
	if G_Music_Current ~= 0 then
		G_Music[G_Music_Current].file:stop()
	end
	G_Music_Current = G_Music_Current + 1
	if G_Music_Current > #G_Music then
		G_Music_Current = 0
	end
	if G_Music_Current ~= 0 then
		G_Music[G_Music_Current].file:play()
	end
end

function love.joystickadded( joystick )
	print("lets get this player set up!")
	SetupPlayer(joystick)
end

function love.joystickremoved( joystick )
	print("Oh no!!")
	DCPlayer(joystick)
end

function love.joystickaxis( joystick, axis, value )
	local id,_ = joystick:getID( )
	local hPlayer = GetPlayer(id)
	if hPlayer then hPlayer:ApplyJInput(axis,value) end
end

function love.joystickpressed( joystick, button )
	local id,_ = joystick:getID( )
	local hPlayer = GetPlayer(id)
	if hPlayer then hPlayer:ApplyBInput(button,joystick) end

end
--function love.gamepadpressed( joystick, button )
--	local id,_ = joystick:getID( )
--	local hPlayer = GetPlayer(id)
--	if hPlayer then hPlayer:ApplyBInput(button) end
--end

function SetupPlayers ()
	if G_Players == nil then
		G_Players = {}
	end
end

function SetupPlayer (joystick)
	local id = 0
	if joystick ~= nil then
		id,_ = joystick:getID( )
	end
	local hPlayer = GetPlayer(id)
	if hPlayer then
		hPlayer:Reconnected()
		G_PlayerCount = G_PlayerCount + 1
		return
	end
	local hPlayer = GamePlayer(id)
	table.insert(G_Players,hPlayer)
	RegisterId(id,hPlayer)
	G_PlayerCount = G_PlayerCount + 1
end

function SetupKeyBoardPlayer(n)
	local id = 665 + n
	local hPlayer = GetPlayer(id)
	if hPlayer then
			if hPlayer:IsActive() then
				hPlayer:Disconnected()
				G_PlayerCount = G_PlayerCount - 1
			else
				hPlayer:Reconnected()
				G_PlayerCount = G_PlayerCount + 1
			end
			return
	end
	print("Adding " .. id)
	G_PlayerCount = G_PlayerCount + 1
	local hPlayer = GamePlayer(id)
	table.insert(G_Players,hPlayer)
	RegisterId(id,hPlayer)
end

function FakeJKeyBoardPlayer(key)
	local id = 666
	local axis = -1
	local value = 0
	local button = -1
	if key == "kp8" then
		axis = 2
		value = -1
	elseif key == "kp5" then
		axis = 2
		value = 1
	elseif key == "kp4" then
		axis = 1
		value = -1
	elseif key == "kp6" then
		axis = 1
		value = 1
	elseif key == "kp0" then
		button = 3
	elseif key == "kp7" then
		button = 9
	elseif key == "kp9" then
		button = 10
	elseif key == "w" then
		axis = 2
		value = -1
		id = 667
	elseif key == "s" then
		axis = 2
		value = 1
		id = 667
	elseif key == "a" then
		axis = 1
		value = -1
		id = 667
	elseif key == "d" then
		axis = 1
		value = 1
		id = 667
	elseif key == "tab" then
		button = 3
		id = 667
	elseif key == "q" then
		button = 9
		id = 667
	elseif key == "e" then
		button = 10
		id = 667
	end
	if axis > -1 or button > -1 then
		local hPlayer = GetPlayer(id)
		if hPlayer then
			if axis > -1 then
				hPlayer:ApplyJInput(axis,value)
				hPlayer:ApplyJInput(axis,0)
			elseif button > -1 then
				hPlayer:ApplyBInput(button)
			end
		end
	end
end

function DCPlayer (joystick)
	local id = 0
	if joystick ~= nil then
		id,_ = joystick:getID( )
	end
	local hPlayer = GetPlayer(id)
	if hPlayer then
		hPlayer:Disconnected()
		G_PlayerCount = G_PlayerCount - 1
	end
end

function RenderPlayers()
	local n = #G_Players
	local b = 0
	for k,v in pairs(G_Players) do
		if v:IsActive() then
			b = b + 1
		end
		v:RenderGrid(n,b)
	end
end

function UpdatePlayers(dt)
	local n = #G_Players
	local b = 0
	for k,v in pairs(G_Players) do
		b = b + 1
		v:UpdateGrid(dt)
	end
end

function UpdateBackGround (dt)
	for k,v in pairs(G_BGStuff) do
		v:Update(dt)
	end
end

function GenBackGround (n)
	G_BGStuff = {}
	for i=1,n do
		G_BGStuff[i] = BackgroundObject(math.random(0,G_WW),math.random(0,G_WH))
	end
end

function DrawBackGround()
	for k,v in pairs(G_BGStuff) do
		v:Render()
	end
end

function DebugPlayerCount()
	for i=1,4 do
		G_PlayerCount = G_PlayerCount + 1
		table.insert(G_Players,GamePlayer(i))
	end
end

function InitRegistery()
	G_Registry = {}
end

function RegisterId(id,hPlayer)
	G_Registry[id] = hPlayer
end

function UnregisterId(id)
	G_Registry[id] = nil
end

function GetPlayer(id)
	if G_Registry[id] ~= nil then
		return G_Registry[id]
	else
		return nil
	end
end

function GenerateMusicList()
G_Music = {}
local dir = "music"
local mt = love.filesystem.getDirectoryItems( dir )
local n = 0
for k,v in pairs(mt) do
	if string.find(v,".mp3") or  string.find(v,".ogg") then
		n = n + 1
		local name = string.gsub(v,".mp3","")
		name = string.gsub(name,".ogg","")
		name = string.gsub(name,"_"," ")
		G_Music[n] = {
				file =	love.audio.newSource( dir .. "/" .. v, "stream" )
		,		name = name
		}
	end
end
G_Music_Current = math.random(1,#G_Music )
end
