GameTile = class(function(self,_shape,_colourRed,_colourGreen,_colourBlue)
	local __shape = _shape or 1
	local __colourRed = 	_colourRed or 255
	local __colourGreen = _colourGreen or 255
	local __colourBlue = 	_colourBlue or 255
	self:InitTile(__shape,__colourRed,__colourGreen,__colourBlue)
	return self
end)

GameTile.InitTile = function(self,_shape,_r,_g,_b)
	self.colour = {r=_r,g=_g,b=_b}
	self.shape = {}
	self.pos = {x=5,y=1}
	local x = 0
	local y = 0
	if _shape == 1 then --I shape
		self.shape[1] = GameBlock(self,-1,0,_r,_g,_b,4)
		self.shape[2] = GameBlock(self,0,0,_r,_g,_b,0)
		self.shape[3] = GameBlock(self,1,0,_r,_g,_b,0)
		self.shape[4] = GameBlock(self,2,0,_r,_g,_b,2)
	elseif _shape == 2 then --T shape
		self.shape[1] = GameBlock(self,-1,0,_r,_g,_b,4)
		self.shape[2] = GameBlock(self,0,0,_r,_g,_b,0)
		self.shape[3] = GameBlock(self,1,0,_r,_g,_b,2)
		self.shape[4] = GameBlock(self,0,-1,_r,_g,_b,1)
	elseif _shape == 3 then --L shape
		self.shape[1] = GameBlock(self,-1,0,_r,_g,_b,4)
		self.shape[2] = GameBlock(self,0,0,_r,_g,_b,0)
		self.shape[3] = GameBlock(self,1,0,_r,_g,_b,0)
		self.shape[4] = GameBlock(self,1,-1,_r,_g,_b,1)
	elseif _shape == 4 then --reverse L shape
		self.shape[1] = GameBlock(self,-1,0,_r,_g,_b,0)
		self.shape[2] = GameBlock(self,0,0,_r,_g,_b,0)
		self.shape[3] = GameBlock(self,1,0,_r,_g,_b,2)
		self.shape[4] = GameBlock(self,-1,-1,_r,_g,_b,1)
	elseif _shape == 5 then --S shape
		self.shape[1] = GameBlock(self,-1,0,_r,_g,_b,4)
		self.shape[2] = GameBlock(self,0,0,_r,_g,_b,0)
		self.shape[3] = GameBlock(self,1,-1,_r,_g,_b,2)
		self.shape[4] = GameBlock(self,0,-1,_r,_g,_b,0)
	elseif _shape == 6 then --Z shape
		self.shape[1] = GameBlock(self,-1,-1,_r,_g,_b,4)
		self.shape[2] = GameBlock(self,0,0,_r,_g,_b,0)
		self.shape[3] = GameBlock(self,1,0,_r,_g,_b,2)
		self.shape[4] = GameBlock(self,0,-1,_r,_g,_b,0)
	elseif _shape == 7 then --O shape
		self.shape[1] = GameBlock(self,0,0,_r,_g,_b,0)
		self.shape[2] = GameBlock(self,0,-1,_r,_g,_b,0)
		self.shape[3] = GameBlock(self,1,0,_r,_g,_b,0)
		self.shape[4] = GameBlock(self,1,-1,_r,_g,_b,0)
	end
end

GameTile.GetPos = function(self)
	return self.pos.x, self.pos.y
end


GameTile.GetTileShapePos = function(self)
	local t = {}
	for k,v in pairs(self.shape) do
		local x,y = v:GetPos(true)
		table.insert(t,{x=x,y=y})
	end
	return t
end

GameTile.Move = function(self,x,y)
	self.pos.x = self.pos.x + x
	self.pos.y = self.pos.y + y
end

GameTile.Rotate = function(self,d)
		for k,v in pairs(self.shape) do
			v:RotPos(d,d*-1)
		end
end

GameTile.GetTileRotPos = function(self,d)
	local t = {}
	for k,v in pairs(self.shape) do
		local x,y = v:RotPos(d,d*-1,true)
		table.insert(t,{x=x,y=y})
	end
	return t
end

GameTile.Destroy = function (self)
	self = nil
end

GameTile.GetBlocks = function (self)
	return self.shape
end
